#include "sprox_desfire_i.h"

#ifndef SPROX_API_REENTRANT 
  SPROX_DESFIRE_CTX_ST desfire_ctx = { 0xFF, 0xFF, { 0 }, 0, { 0 }, { 0 }, { 0 } };
#endif

#ifdef SPROX_API_REENTRANT

#define MAX_INSTANCES 16

typedef struct
{
  SPROX_INSTANCE        sprox_ctx;
  SPROX_DESFIRE_CTX_ST *desfire_ctx;

} INSTANCE_ST;

INSTANCE_ST instances[MAX_INSTANCES] = { 0 };

/*
 * Desfire higher level functions
 * ------------------------------
 */
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_AttachDesfireLibrary(SPROX_INSTANCE rInst)
{
  BYTE i;
  
  for (i=0; i<MAX_INSTANCES; i++)
    if (instances[i].sprox_ctx == rInst)
      goto take_this_one;
  
  for (i=0; i<MAX_INSTANCES; i++)
    if (instances[i].sprox_ctx == NULL)
      goto take_this_one;
  
  return MI_LIB_INTERNAL_ERROR;
  
take_this_one:

  instances[i].desfire_ctx = malloc(sizeof(SPROX_DESFIRE_CTX_ST));
  if (instances[i].desfire_ctx == NULL)
    return MI_OUT_OF_MEMORY_ERROR;   
  instances[i].sprox_ctx = rInst;
  
  memset(instances[i].desfire_ctx, 0, sizeof(SPROX_DESFIRE_CTX_ST));
  instances[i].desfire_ctx->cid = 0xFF;
  instances[i].desfire_ctx->auth_key = 0xFF;
  
  return MI_OK;
}

SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_DetachDesfireLibrary(SPROX_INSTANCE rInst)
{
  BYTE i;
  
  for (i=0; i<MAX_INSTANCES; i++)
  {
    if (instances[i].sprox_ctx == rInst)
    {
      if (instances[i].desfire_ctx != NULL)
        free(instances[i].desfire_ctx);
      instances[i].desfire_ctx = NULL;
      instances[i].sprox_ctx = NULL;
      return MI_OK;
    }
  }

  return MI_INVALID_READER_CONTEXT;  
}

SPROX_DESFIRE_CTX_ST *desfire_get_ctx(SPROX_INSTANCE rInst)
{
  BYTE i;
  
  for (i=0; i<MAX_INSTANCES; i++)
    if (instances[i].sprox_ctx == rInst)
      return instances[i].desfire_ctx;

  return NULL;  
}

#endif
