#include "cardappz.h"

int DesfireBlank(CARDAPPZ_CTX_ST * ctx)
{
  int rc;

  rc = DesfireSelectCard(ctx);
  if (rc)
    return rc;

  rc = DesfireBlankCard(ctx);
  if (rc)
    return rc;

  return CARDAPPZ_OK;
}

int JaycosBlank(CARDAPPZ_CTX_ST * ctx)
{
  int rc;

  rc = JaycosSelectCard(ctx);
  if (rc)
    return rc;

  rc = JaycosBlankCard(ctx);
  if (rc)
    return rc;

  return CARDAPPZ_OK;
}

int Blank(CARDAPPZ_CTX_ST * ctx)
{
  if (ctx == NULL)
    return CARDAPPZ_INVALID_CONTEXT;

  switch (ctx->card_type)
  {
    case CARD_DESFIRE:
      return DesfireBlank(ctx);
    case CARD_JAYCOS:
      return JaycosBlank(ctx);
  }

  return CARDAPPZ_NOT_YET_IMPLEMENTED;
}
