unit uCSBTest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TfCsbTest = class(TForm)
    pBottom: TPanel;
    bsBot: TBevel;
    btnOK: TButton;
    pMain: TPanel;
    lbSnr: TLabel;
    eTagSnr: TEdit;
    mData: TMemo;
    eTagAtq: TEdit;
    Label1: TLabel;
    eTagSak: TEdit;
    Label2: TLabel;
    btnSelect: TButton;
    btnRead: TButton;
    btnWrite: TButton;
    status: TStatusBar;
    btnRead768: TButton;
    btnWrite768: TButton;
    procedure btnOKClick(Sender: TObject);
    procedure btnSelectClick(Sender: TObject);
    procedure btnReadClick(Sender: TObject);
    procedure btnWriteClick(Sender: TObject);
    procedure btnRead768Click(Sender: TObject);
    procedure btnWrite768Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fCsbTest: TfCsbTest;

implementation

uses uCsbDyn;

{$R *.dfm}

procedure TfCsbTest.btnOKClick(Sender: TObject);
begin
   Close;
end;

procedure TfCsbTest.btnSelectClick(Sender: TObject);
var
   TagSnr : string;
   TagAtq : string;
   TagSak : string;
   rc     : sword;
begin
   rc := SelectTag(TagSnr, TagAtq, TagSak);
   if rc <> 0 then Application.MessageBox(pchar(GetErrorMessage(rc)), 'CSB Test - Select tag', 0);
   eTagSnr.Text := TagSnr;
   eTagAtq.Text := TagAtq;
   eTagSak.Text := TagSak;
   if rc = 0 then Status.SimpleText := 'Select OK'
             else Status.SimpleText := 'No tag selected';
end;

procedure TfCsbTest.btnReadClick(Sender: TObject);
var
   title    : string;
   data     : string;
   sect     : byte;
   rc       : sword;
   t0, t1   : dword;
begin
   t0 := GetTickCount;
   mData.Lines.Clear;
   for sect := 0 to 15 do
   begin
      Title := 'CSB Test - Read sector ' + IntToStr(sect);
      Status.SimpleText := Title + ' ...';
      Application.ProcessMessages;
      rc := ReadSector(sect, data);
      if rc <> 0 then
      begin
         Status.SimpleText := Title + ' ECHEC';
         Application.ProcessMessages;
         Application.MessageBox(pchar(GetErrorMessage(rc)), pchar(title), 0);
      end else
      begin
         Status.SimpleText := Title + ' OK';
         Application.ProcessMessages;
      end;
      mData.Lines.Add(data);
   end;
   t1 := GetTickCount;
   Status.SimpleText := Format('Done, %dms', [t1 - t0]);
end;

procedure TfCsbTest.btnWriteClick(Sender: TObject);
var
   title    : string;
   data     : string;
   sect     : byte;
   rc       : sword;
   t0, t1   : dword;
begin
   t0 := GetTickCount;
   for sect := 0 to 15 do
   begin
      try
         data := mData.Lines[sect];
      except
         continue;
      end;
      if length(data) <> 96 then continue;
      Title := 'CSB Test - Write sector ' + IntToStr(sect);
      Status.SimpleText := Title + ' ...';
      Application.ProcessMessages;
      rc := WriteSector(sect, data);
      if rc <> 0 then
      begin
         Status.SimpleText := Title + ' ECHEC';
         Application.ProcessMessages;
         Application.MessageBox(pchar(GetErrorMessage(rc)), pchar(title), 0);
      end else
      begin
         Status.SimpleText := Title + ' OK';
         Application.ProcessMessages;
      end;
   end;
   Status.SimpleText := '';
   t1 := GetTickCount;
   Status.SimpleText := Format('Done, %dms', [t1 - t0]);
end;

procedure TfCsbTest.btnRead768Click(Sender: TObject);
var
   title    : string;
   data     : string;
   sect     : byte;
   mask     : word;
   sectors  : word;
   rc       : sword;
   t0, t1   : dword;
begin
   t0 := GetTickCount;
   mData.Lines.Clear;
   Title := 'CSB Test - Reading 16 sectors at once';
   Status.SimpleText := Title + ' ...';
   Application.ProcessMessages;
   sectors := $FFFF;
   rc := ReadTag(sectors, data);
   if rc <> 0 then
   begin
      Status.SimpleText := Title + ' ECHEC';
      Application.ProcessMessages;
      Application.MessageBox(pchar(GetErrorMessage(rc)), pchar(title), 0);
   end else
   begin
      Status.SimpleText := Title + ' OK';
      Application.ProcessMessages;
      if length(data) = 1536 then
      begin
         mask := 1;
         for sect := 0 to 15 do
         begin
            if sectors and mask <> 0 then
            begin
               mData.Lines.Add(Copy(data, 1, 96));
            end else
            begin
               mData.Lines.Add('');
            end;
            Delete(data, 1, 96);
            mask := mask * 2;
         end;
      end;
   end;
   Status.SimpleText := '';
   t1 := GetTickCount;
   Status.SimpleText := Format('Done, %dms', [t1 - t0]);
end;

procedure TfCsbTest.btnWrite768Click(Sender: TObject);
var
   title    : string;
   data     : string;
   line     : string;
   sect     : byte;
   mask     : word;
   sectors  : word;
   rc       : sword;
   t0, t1   : dword;
begin
   t0 := GetTickCount;
   Title := 'CSB Test - Writing 16 sectors at once';
   Status.SimpleText := Title + ' ...';
   Application.ProcessMessages;
   sectors := 0;
   mask := 1;
   data := '';
   for sect := 0 to 15 do
   begin
      try
         line := mData.Lines[sect];
      except
         data := data + '000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
         continue;
      end;
      if length(line) <> 96 then
      begin
         data := data + '000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
         continue;
      end;
      data := data + line;
      sectors := sectors or mask;
      mask := mask * 2;
   end;
   rc := WriteTag(sectors, data);
   if rc <> 0 then
   begin
      Status.SimpleText := Title + ' ECHEC';
      Application.ProcessMessages;
      Application.MessageBox(pchar(GetErrorMessage(rc)), pchar(title), 0);
   end else
   begin
      Status.SimpleText := Title + ' OK';
      Application.ProcessMessages;
   end;
   Status.SimpleText := '';
   t1 := GetTickCount;
   Status.SimpleText := Format('Done, %dms', [t1 - t0]);
end;

end.
