unit uMfTool;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, IniFiles, jpeg;

type
  TfMfTool = class(TForm)
    status: TStatusBar;
    pTop: TPanel;
    lbTitle: TLabel;
    lbCaption: TLabel;
    imgLogo: TImage;
    pLeft: TPanel;
    img14443: TImage;
    btnReaderOpen: TButton;
    btnReaderClose: TButton;
    btnTagSelect: TButton;
    lbSect: TLabel;
    eSect: TEdit;
    udSect: TUpDown;
    lbData: TLabel;
    lbBloc0: TLabel;
    lbBloc1: TLabel;
    lbBloc2: TLabel;
    eBloc2: TEdit;
    eBloc1: TEdit;
    eBloc0: TEdit;
    lbAccess: TLabel;
    lbKeyA: TLabel;
    lbKeyB: TLabel;
    cbKeyB: TComboBox;
    cbKeyA: TComboBox;
    eCount0: TEdit;
    udCount0: TUpDown;
    lbCount: TLabel;
    eCount1: TEdit;
    udCount2: TUpDown;
    eCount2: TEdit;
    udCount1: TUpDown;
    btnReadSect: TButton;
    btnBloc0Decr: TButton;
    btnBloc1Decr: TButton;
    btnBloc2Decr: TButton;
    btnWriteSect: TButton;
    btnWriteAC: TButton;
    btnGuessKeys: TButton;
    lbSnr: TLabel;
    eSnr: TEdit;
    cbCounter0: TCheckBox;
    cbCounter1: TCheckBox;
    cbCounter2: TCheckBox;
    Image1: TImage;
    procedure btnReadSectClick(Sender: TObject);
    procedure udSectClick(Sender: TObject; Button: TUDBtnType);
    procedure btnWriteSectClick(Sender: TObject);
    procedure btnWriteACClick(Sender: TObject);
    procedure btnBloc0DecrClick(Sender: TObject);
    procedure btnBloc1DecrClick(Sender: TObject);
    procedure btnBloc2DecrClick(Sender: TObject);
    procedure btnGuessKeysClick(Sender: TObject);
    procedure btnReaderOpenClick(Sender: TObject);
    procedure btnReaderCloseClick(Sender: TObject);
    procedure btnTagSelectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    sect    : byte;
    mif_snr : array[0..4] of byte;
    mif_atq : array[0..1] of byte;
    mif_ats : array[0..0] of byte;
  public
    { Dclarations publiques }
  end;

var
  fMfTool: TfMfTool;

implementation

{$R *.dfm}

uses uSpringProxDll;

procedure TfMfTool.udSectClick(Sender: TObject; Button: TUDBtnType);
begin
   sect := StrToIntDef(eSect.Text, 0);
   eSect.Text := IntToStr(sect);

   eBloc0.Text := '';
   eBloc1.Text := '';
   eBloc2.Text := '';
   udCount0.Position := 0;
   udCount1.Position := 0;
   udCount2.Position := 0;
   cbKeyA.ItemIndex := -1;
   cbKeyB.ItemIndex := -1;
   cbCounter0.Checked := false;
   cbCounter1.Checked := false;
   cbCounter2.Checked := false;
end;

procedure TfMfTool.btnReadSectClick(Sender: TObject);
var
   rc : sword;
   buffer     : array[1..48] of byte;  // One Mifare sector is 48 bytes len
   str_buffer : array[1..97] of char;  // 2*48 bytes + terminal char
   str        : string;
   counter    : longint;
   ac         : byte;
begin
   Enabled := false;

   eBloc0.Text := '';
   eBloc1.Text := '';
   eBloc2.Text := '';
   udCount0.Position := 0;
   udCount1.Position := 0;
   udCount2.Position := 0;
   cbKeyA.ItemIndex := -1;
   cbKeyB.ItemIndex := -1;
   cbCounter0.Checked := false;
   cbCounter1.Checked := false;
   cbCounter2.Checked := false;

   //
   // This is how to read one Mifare sector
   // -------------------------------------
   // Param 'key' MUST be NULL for CSB3 and prior. All available A keys are tried first, then
   // all available B keys, until successfull reading
   //

   rc := SPROX_MifStReadSector(@mif_snr, sect, @buffer, nil);
   if rc = 0 then
   begin
      rc := SPROX_ArrayToString(pchar(@str_buffer), @buffer, sizeof(buffer));
      if rc = 0 then
      begin
         str := StrPas(pchar(@str_buffer));
         eBloc0.Text := Copy(str, 1, 32);
         eBloc1.Text := Copy(str, 33, 32);
         eBloc2.Text := Copy(str, 65, 32);
      end else
      begin
         ShowMessage('Failed to format buffer (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
      end;
      // Read the sector trailer (access control block)
      rc := SPROX_MifStReadBlock(@mif_snr, 4*sect+3, @buffer, nil);
      if rc = 0 then
      begin
         rc := SPROX_ArrayToString(pchar(@str_buffer), @buffer, sizeof(buffer));
         if rc = 0 then
         begin
            // This is Mifare internal jam...
            ac := 0;
            if (buffer[8] and $10) = $10 then ac := (ac or $04);
            if (buffer[9] and $01) = $01 then ac := (ac or $02);
            if (buffer[9] and $10) = $10 then ac := (ac or $01);
            cbCounter0.Checked := (ac = acc_counter);
            ac := 0;
            if (buffer[8] and $20) = $20 then ac := (ac or $04);
            if (buffer[9] and $02) = $02 then ac := (ac or $02);
            if (buffer[9] and $20) = $20 then ac := (ac or $01);
            cbCounter1.Checked := (ac = acc_counter);
            ac := 0;
            if (buffer[8] and $40) = $40 then ac := (ac or $04);
            if (buffer[9] and $04) = $04 then ac := (ac or $02);
            if (buffer[9] and $40) = $40 then ac := (ac or $01);
            cbCounter2.Checked := (ac = acc_counter);
         end;
         if cbCounter0.Checked then
         begin
            eBloc0.Enabled := false;
            udCount0.Enabled := true;
            btnBloc0Decr.Enabled := true;
            rc := SPROX_MifStReadCounter(@mif_snr, 4*sect+0, counter, nil);
            if rc = 0 then
            begin
               if (counter > $8000) or (counter < -$8000) then ShowMessage('Value for counter 0 exceeds valid range')
                                                          else udCount0.Position := counter;
            end else
            begin
               ShowMessage('Failed to read counter in block 0 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
            end;
         end else
         begin
            eBloc0.Enabled := true;
            udCount0.Enabled := false;
            btnBloc0Decr.Enabled := false;
         end;
         if cbCounter1.Checked then
         begin
            eBloc1.Enabled := false;
            udCount1.Enabled := true;
            btnBloc1Decr.Enabled := true;
            rc := SPROX_MifStReadCounter(@mif_snr, 4*sect+1, counter, nil);
            if rc = 0 then
            begin
               if (counter > $8000) or (counter < -$8000) then ShowMessage('Value for counter 1 exceeds valid range')
                                                          else udCount1.Position := counter;
            end else
            begin
               ShowMessage('Failed to read counter in block 1 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
            end;
         end else
         begin
            eBloc1.Enabled := true;
            udCount1.Enabled := false;
            btnBloc1Decr.Enabled := false;
         end;
         if cbCounter2.Checked then
         begin
            eBloc2.Enabled := false;
            udCount2.Enabled := true;
            btnBloc2Decr.Enabled := true;
            rc := SPROX_MifStReadCounter(@mif_snr, 4*sect+2, counter, nil);
            if rc = 0 then
            begin
               if (counter > $8000) or (counter < -$8000) then ShowMessage('Value for counter 2 exceeds valid range')
                                                          else udCount2.Position := counter;
            end else
            begin
               ShowMessage('Failed to read counter in block 2 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
            end;
         end else
         begin
            eBloc2.Enabled := true;
            udCount2.Enabled := false;
            btnBloc2Decr.Enabled := false;
         end;
      end else
      begin
         ShowMessage('Failed to read sector trailer (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
      end;
   end else
   begin
      ShowMessage('Failed to read block (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;

   Enabled := true;
end;

procedure TfMfTool.btnWriteSectClick(Sender: TObject);
var
   rc : sword;
   buffer     : array[1..48] of char;  // One Mifare sector is 48 bytes len
   str        : string;
begin
   Enabled := false;

   //
   // This is how to write one Mifare sector
   // --------------------------------------
   // Param 'key' MUST be NULL for CSB3 and prior. All available B keys are tried first, then
   // all available A keys, until successfull writing
   //

   str := eBloc0.Text + eBloc1.Text + eBloc2.Text;
   rc := SPROX_StringToArray(@buffer, pchar(str), sizeof(buffer));
   if rc = 0 then
   begin
      rc := SPROX_MifStWriteSector(@mif_snr, sect, @buffer, nil);
      if rc = 0 then
      begin
         ShowMessage('Data have been successfully written');
      end else
      begin
         ShowMessage('Failed to write the sector (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
      end;
      if cbCounter0.Checked then
      begin
         rc := SPROX_MifStWriteCounter(@mif_snr, 4*sect, udCount0.Position, nil);
         if rc <> 0 then
         begin
            ShowMessage('Failed to read counter in block 0 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
         end;
      end;
      if cbCounter1.Checked then
      begin
         rc := SPROX_MifStWriteCounter(@mif_snr, 4*sect+1, udCount1.Position, nil);
         if rc <> 0 then
         begin
            ShowMessage('Failed to read counter in block 1 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
         end;
      end;
      if cbCounter2.Checked then
      begin
         rc := SPROX_MifStWriteCounter(@mif_snr, 4*sect+2, udCount2.Position, nil);
         if rc <> 0 then
         begin
            ShowMessage('Failed to read counter in block 2 (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
         end;
      end;
   end else
   begin
      ShowMessage('Invalid data (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;

   btnReadSectClick(Sender);
end;

procedure TfMfTool.btnWriteACClick(Sender: TObject);
var
   rc            : sword;
   pa, pb        : pointer;
   ac0, ac1, ac2 : byte;
begin

   if (cbKeyA.ItemIndex = -1) or (cbKeyB.ItemIndex = -1) then
   begin
      ShowMessage('You must select both A & B keys');
      Exit;
   end;

   Enabled := false;

   case cbKeyA.ItemIndex of
   0 : pa := @key_aaaaaa;
   1 : pa := @key_demo_a;
   2 : pa := @key_test_a;
   else
       pa := @key_ffffff;
   end;

   case cbKeyB.ItemIndex of
   0 : pb := @key_bbbbbb;
   1 : pb := @key_demo_b;
   2 : pb := @key_test_b;
   else
       pb := @key_ffffff;
   end;

   ac0 := acc_normal;
   ac1 := acc_normal;
   ac2 := acc_normal;
   if cbCounter0.Checked then ac0 := acc_counter;
   if cbCounter1.Checked then ac1 := acc_counter;
   if cbCounter2.Checked then ac2 := acc_counter;

   //
   // This is how to alter the sector's security block (block 3)
   // ----------------------------------------------------------
   // Param 'old_key' MUST be NULL for CSB3 and prior. All available A keys are tried first, then
   // all available B keys, until successfull writing.
   // Access conditions for data blocks (ac0, ac1, ac2) and for the security block (ac3) must meet
   // requirements (respectively 'acc_normal' and 'acc_security'). Be very carefully when trying
   // others values, this may lead to the sector becoming unusable !!!
   //

   rc := SPROX_MifStUpdateAccessBlock(@mif_snr, sect, nil, pa, pb, ac0, ac1, ac2, acc_security);
   if rc = 0 then
   begin
      ShowMessage('Access conditions have been successfully written');
   end else
   begin
      ShowMessage('Failed to write the A.C. (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;

   btnReadSectClick(Sender);
end;

procedure TfMfTool.btnBloc0DecrClick(Sender: TObject);
var
   rc            : sword;
begin
   Enabled := false;
   rc := SPROX_MifStDecrementCounter(@mif_snr, 4*sect+0, 1, nil);
   if rc <> 0 then
   begin
      ShowMessage('Failed to decrement the counter (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;
   btnReadSectClick(Sender);
end;

procedure TfMfTool.btnBloc1DecrClick(Sender: TObject);
var
   rc            : sword;
begin
   Enabled := false;
   rc := SPROX_MifStDecrementCounter(@mif_snr, 4*sect+1, 1, nil);
   if rc <> 0 then
   begin
      ShowMessage('Failed to decrement the counter (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;
   btnReadSectClick(Sender);
end;

procedure TfMfTool.btnBloc2DecrClick(Sender: TObject);
var
   rc            : sword;
begin
   Enabled := false;
   rc := SPROX_MifStDecrementCounter(@mif_snr, 4*sect+2, 1, nil);
   if rc <> 0 then
   begin
      ShowMessage('Failed to decrement the counter (' + StrPas(SPROX_GetErrorMessage(rc)) + ')');
   end;
   btnReadSectClick(Sender);
end;

procedure TfMfTool.btnGuessKeysClick(Sender: TObject);
var
   id : byte;
   rc : sword;
begin
   Enabled := false;
   // This shows how to use low-level API calls
   cbKeyA.ItemIndex := -1;
   cbKeyB.ItemIndex := -1;

   for id := 0 to 3 do
   begin
      rc := SPROX_MifStSelectAgain(@mif_snr);
      if rc = 0 then
      begin
         // $60 --> PICC_AUTHENT1A
         rc := Mf500PiccAuthRam($60, id, 4*sect);
         if rc = 0 then
         begin
            ShowMessage(Format('key A: %s', [cbKeyA.Items[id]]));
            cbKeyA.ItemIndex := id;
            break;
         end;
      end;
   end;
   if rc <> 0 then
   for id := 0 to 15 do
   begin
      rc := Mf500PiccAuth($60, id, 4*sect);
      if rc = 0 then
      begin
         ShowMessage(Format('key A: secured EEPROM at offset %d', [id]));
         break;
      end;
   end;
   if rc <> 0 then
   begin
      ShowMessage('key A: unknown');
   end;
   for id := 0 to 3 do
   begin
      rc := SPROX_MifStSelectAgain(@mif_snr);
      if rc = 0 then
      begin
         // $61 --> PICC_AUTHENT1B
         rc := Mf500PiccAuthRam($61, id, 4*sect);
         if rc = 0 then
         begin
            ShowMessage(Format('key B: %s', [cbKeyB.Items[id]]));
            cbKeyB.ItemIndex := id;            
            break;
         end;
      end;
   end;
   if rc <> 0 then
   for id := 0 to 15 do
   begin
      rc := Mf500PiccAuth($61, id, 4*sect);
      if rc = 0 then
      begin
         ShowMessage(Format('key B: secured EEPROM at offset %d', [id]));
         break;
      end;
   end;
   if rc <> 0 then
   begin
      ShowMessage('key B: unknown');
   end;
   Enabled := true;
end;

procedure TfMfTool.btnReaderOpenClick(Sender: TObject);
var
   rc     : sword;
   buffer : array[1..128] of char;
begin
   btnReaderOpen.Enabled := false;
   //
   // Try to open the reader
   // ----------------------
   // Setting device to NULL leads to the automatic discovery procedure
   //
   rc := SPROX_ReaderOpen(nil);
   if rc = 0 then
   begin
      // Success

      //
      // Load Mifare access keys into reader memory
      // ------------------------------------------
      // - When using SpringProx-CF or CSB-4, the keys can be saved in EEPROM, setting the 'eeprom' parameter to
      //   true. In this case, they have to be written only once (unless overwritten by another application).
      // - When using CSB-3, the keys are stored in RAM. They have to be written after each power-up. The 'eeprom'
      //   parameter MUST be set to false. The CSB-3 has buffers for 4 A keys, and 4 B keys.
      //

                     rc := SPROX_MifLoadKey(false, 'A', 0, @key_aaaaaa);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'A', 1, @key_demo_a);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'A', 2, @key_test_a);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'A', 3, @key_ffffff);

      if rc = 0 then rc := SPROX_MifLoadKey(false, 'B', 0, @key_bbbbbb);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'B', 1, @key_demo_b);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'B', 2, @key_test_b);
      if rc = 0 then rc := SPROX_MifLoadKey(false, 'B', 3, @key_ffffff);

      if rc <> 0 then ShowMessage('Failed to load the Mifare access keys');

      // Get reader device name
      // ----------------------

      rc := SPROX_ReaderGetDevice(pchar(@buffer), sizeof(buffer));
      if rc = 0 then
      begin
         status.SimpleText := 'Connected, reader found on ' + StrPas(pchar(@buffer));
      end else
      begin
         status.SimpleText := 'Connected, unknown port (' + StrPas(SPROX_GetErrorMessage(rc)) + ')';
      end;

      // OK
      btnReaderClose.Enabled := true;
      btnTagSelect.Enabled := true;
   end else
   begin
      // Failure
      btnReaderOpen.Enabled := true;
   end;
end;

procedure TfMfTool.btnReaderCloseClick(Sender: TObject);
var
   rc : sword;
begin
   btnReaderClose.Enabled := false;
   btnTagSelect.Enabled := false;

   eBloc0.Enabled := false;
   eBloc1.Enabled := false;
   eBloc2.Enabled := false;
   udCount0.Enabled := false;
   udCount1.Enabled := false;
   udCount2.Enabled := false;
   cbKeyA.Enabled := false;
   cbKeyB.Enabled := false;
   cbCounter0.Enabled := false;
   cbCounter1.Enabled := false;
   cbCounter2.Enabled := false;
   btnReadSect.Enabled := false;
   btnWriteSect.Enabled := false;
   btnGuessKeys.Enabled := false;
   btnWriteAC.Enabled := false;
   udSect.Enabled := false;

   //
   // Disconnect from the reader
   // --------------------------
   //

   rc := SPROX_ReaderClose;
   if rc = 0 then
   begin
      // Success
      Status.SimpleText := 'Connection has been closed';
   end else
   begin
      // Failure
      Status.SimpleText := StrPas(SPROX_GetErrorMessage(rc));
   end;

   btnReaderOpen.Enabled := true;
end;

procedure TfMfTool.btnTagSelectClick(Sender: TObject);
var
   rc : sword;
begin
   sect := 0;
   eSect.Text := IntToStr(sect);
   eBloc0.Text := '';
   eBloc1.Text := '';
   eBloc2.Text := '';
   udCount0.Position := 0;
   udCount1.Position := 0;
   udCount2.Position := 0;
   cbKeyA.ItemIndex := -1;
   cbKeyB.ItemIndex := -1;
   cbCounter0.Checked := false;
   cbCounter1.Checked := false;
   cbCounter2.Checked := false;

   eBloc0.Enabled := false;
   eBloc1.Enabled := false;
   eBloc2.Enabled := false;
   udCount0.Enabled := false;
   udCount1.Enabled := false;
   udCount2.Enabled := false;
   cbKeyA.Enabled := false;
   cbKeyB.Enabled := false;
   cbCounter0.Enabled := false;
   cbCounter1.Enabled := false;
   cbCounter2.Enabled := false;
   btnReadSect.Enabled := false;
   btnWriteSect.Enabled := false;
   btnGuessKeys.Enabled := false;
   btnWriteAC.Enabled := false;
   udSect.Enabled := false;

   //
   // Lookup for a Mifare tag
   // -----------------------
   // SPROX_MifStSelectAny retrieve the tag serial number, answer to query (atq) and answer to select (ats)
   //

   rc := SPROX_MifStSelectAny(@mif_snr, @mif_atq, @mif_ats);
   if (rc = 0) then
   begin
      // Tag found
      Status.SimpleText := Format('Found tag with SNR=%0.2X%0.2X%0.2X%0.2X (ATQ=%0.2X%0.2X, ATS=%0.2X)', [
                               mif_snr[3], mif_snr[2], mif_snr[1], mif_snr[0],
                               mif_atq[0], mif_atq[1],
                               mif_ats[0] ]);
      eSnr.Text := Format('%0.2X%0.2X%0.2X%0.2X', [mif_snr[3], mif_snr[2], mif_snr[1], mif_snr[0]]);

      eBloc0.Enabled := true;
      eBloc1.Enabled := true;
      eBloc2.Enabled := true;
      udCount0.Enabled := true;
      udCount1.Enabled := true;
      udCount2.Enabled := true;
      cbKeyA.Enabled := true;
      cbKeyB.Enabled := true;
      cbCounter0.Enabled := true;
      cbCounter1.Enabled := true;
      cbCounter2.Enabled := true;
      btnReadSect.Enabled := true;
      btnWriteSect.Enabled := true;
      btnGuessKeys.Enabled := true;
      btnWriteAC.Enabled := true;
      udSect.Enabled := true;

   end else
   if (rc = -1) then
   begin
      // No tag in reader area...
      Status.SimpleText := 'No tag in reader area';
   end else
   begin
      // Failure
      Status.SimpleText := StrPas(SPROX_GetErrorMessage(rc));
   end;
end;

procedure TfMfTool.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SPROX_ReaderClose;
end;

procedure TfMfTool.FormCreate(Sender: TObject);
var
   ini : TIniFile;
   pic : TPicture;
   str_company : string;
   str_logo    : string;
   str_product : string;
begin
   ini := TIniFile.Create(ExtractFileDir(Application.ExeName) + '\csbinfo.ini');
   str_company := ini.ReadString('company', 'name', 'SpringCard');
   str_logo    := ini.ReadString('company', 'logo', 'logo_pro-active.bmp');
   str_product := ini.ReadString('product', 'name', 'CSB / SpringProx');
   ini.Free;
   pic := TPicture.Create;
   try
      pic.LoadFromFile(str_logo);
      imgLogo.Left := pTop.Width - 8 - pic.Width;
      imgLogo.Picture.Assign(pic);
   except
      // No picture !
   end;
   pic.Free;
   Caption := str_company + ' ' + str_product + ' - MfTool Sample Project';
end;

end.
