#ifndef uWorkerH
#define uWorkerH

#include <Classes.hpp>

#define IDENT_SIZE   80
#define FINGERS_SIZE 340
#define PICTURE_SIZE 3072

typedef enum
{
  WORK_TERMINATE = -2,
  WORK_CANCEL = -1,
  WORK_NONE = 0,
  WORK_OPEN_READER,
  WORK_FIND_CARD,
  WORK_READ_CARD,
  WORK_WRITE_CARD,
  WORK_ERASE_CARD,
  WORK_ENROLL,
  WORK_VERIFY
} work_task_e;


class TWorker : public TThread
{
private:
  AnsiString syncLine;

  work_task_e nextTaskCode;
  work_task_e doneTaskCode;

  void *hWakeupEvent;
public:
  bool bReaderActive;
  bool bReaderHasFingerprint;
protected:
  void __fastcall Execute();

  bool __fastcall OpenReaderTask();

  bool __fastcall FindCardTask();
  bool __fastcall ReadCardTask();
  bool __fastcall WriteCardTask();
  bool __fastcall EraseCardTask();
  bool __fastcall EnrollTask();
  void __fastcall EnrollAsyncAction(unsigned char code);
  void __fastcall EnrollAsyncInfo(unsigned char finger_no, unsigned char finger_count, unsigned char capture_no, unsigned char capture_count);
  void __fastcall VerifyAsyncAction(unsigned char code);
  bool __fastcall VerifyTask();

  void __fastcall DecodeUserData(unsigned char buffer[80]);
  void __fastcall EncodeUserData(unsigned char buffer[80]);

  bool __fastcall ReadCardDesfire();
  bool __fastcall WriteCardDesfire();
  bool __fastcall EraseCardDesfire();
  bool __fastcall FormatCardDesfire();

  bool __fastcall ReadCardMifare1k();
  bool __fastcall ReadCardMifare4k();
  bool __fastcall WriteCardMifare1k();
  bool __fastcall WriteCardMifare4k();
  bool __fastcall EraseCardMifare();
  bool __fastcall FormatCardMifare();

  bool __fastcall ReadCardMifareUL();
  bool __fastcall WriteCardMifareUL();
  bool __fastcall EraseCardMifareUL();

  bool __fastcall ReadCardJaycos();
  bool __fastcall WriteCardJaycos();
  bool __fastcall EraseCardJaycos();
  bool __fastcall FormatCardJaycos();

  void __fastcall syncWriteLn();
  void __fastcall WriteLn(AnsiString S);
  void __fastcall WriteRc(short rc);  
  void __fastcall syncTaskSuccess();
  void __fastcall syncTaskFailure();
  void __fastcall TaskDone(bool result);  
public:
  __fastcall TWorker(bool CreateSuspended);
  void __fastcall Cancel();
  void __fastcall Task(work_task_e TaskCode);
  bool __fastcall ReaderActive();
};
//---------------------------------------------------------------------------
#endif
