//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uConfig.h"
#include "uSettings.h"

#include "hardware/springprox/springprox.h"
#include <stdio.h>

#pragma package(smart_init)
#pragma resource "*.dfm"

TfConfig *fConfig;

void __fastcall TfConfig::SettingsToScreen()
{
  /* General screen */
  if (Settings->Device == "")
    rgCsbDevice->ItemIndex = 0;
  else if (Settings->Device == "COM1")
    rgCsbDevice->ItemIndex = 1;
  else if (Settings->Device == "COM2")
    rgCsbDevice->ItemIndex = 2;
  else if (Settings->Device == "COM3")
    rgCsbDevice->ItemIndex = 3;
  else if (Settings->Device == "COM4")
    rgCsbDevice->ItemIndex = 4;
  else if (Settings->Device == "USB")
    rgCsbDevice->ItemIndex = 5;

  if (Settings->ScanMode < rgScanMode->Items->Count)
    rgScanMode->ItemIndex = Settings->ScanMode;

  if (Settings->StartMode < rgStartMode->Items->Count)
    rgStartMode->ItemIndex = Settings->StartMode;

  /* Output screen */
  if (Settings->Prefix == "")
    rgOutputPrefix->ItemIndex = 0;
  else if (Settings->Prefix == "<ENTER>")
    rgOutputPrefix->ItemIndex = 1;
  else if (Settings->Prefix == "<TAB>")
    rgOutputPrefix->ItemIndex = 2;

  if (Settings->Postfix == "")
    rgOutputPostfix->ItemIndex = 0;
  else if (Settings->Postfix == "<ENTER>")
    rgOutputPostfix->ItemIndex = 1;
  else if (Settings->Postfix == "<TAB>")
    rgOutputPostfix->ItemIndex = 2;

  if (Settings->ScanDelay == 0)
    rgScanDelay->ItemIndex = 0;
  else if (Settings->ScanDelay == 1)
    rgScanDelay->ItemIndex = 5;
  else if (Settings->ScanDelay == 2)
    rgScanDelay->ItemIndex = 10;
  else if (Settings->ScanDelay == 3)
    rgScanDelay->ItemIndex = 20;
  else if (Settings->ScanDelay == 4)
    rgScanDelay->ItemIndex = 50;
  else if (Settings->ScanDelay == 10)
    rgScanDelay->ItemIndex = 100;

  if (Settings->ScanFilter < rgScanFilter->Items->Count)
    rgScanFilter->ItemIndex = Settings->ScanFilter;

  cbBeep->Checked = Settings->ScanBeep;
  cbRemoveLeading0->Checked = Settings->RemoveLeading0;

  /* Mifare screen */
  udMifareBlock->Position = Settings->MifareBlock;
  udMifareOffset->Position = Settings->MifareOffset;
  udMifareSize->Position = Settings->MifareSize;
  eMifareKey->Text = Settings->MifareKey;
  if (Settings->MifareFormat < rgMifareFormat->Items->Count)
    rgMifareFormat->ItemIndex = Settings->MifareFormat;
  cbMifareRevert->Checked = Settings->MifareRevert;

  /* 14443-A screen */
  if (Settings->Iso14443aSize < rg14443aSize->Items->Count)
    rg14443aSize->ItemIndex = Settings->Iso14443aSize;
  if (Settings->Iso14443aFormat < rg14443aFormat->Items->Count)
    rg14443aFormat->ItemIndex = Settings->Iso14443aFormat;
  cb14443aRevert->Checked = Settings->Iso14443aRevert;
  cb14443aA->Checked = Settings->Iso14443aA;
  cb14443aATQ->Checked = Settings->Iso14443aATQ;
  cb14443aSAK->Checked = Settings->Iso14443aSAK;

  /* 14443-B screen */
  if (Settings->Iso14443bFormat < rg14443bFormat->Items->Count)
    rg14443bFormat->ItemIndex = Settings->Iso14443bFormat;
  cb14443bRevert->Checked = Settings->Iso14443bRevert;
  cb14443bB->Checked = Settings->Iso14443bB;
}

void __fastcall TfConfig::ScreenToSettings()
{
  /* General screen */
  Settings->ScanMode = rgScanMode->ItemIndex;
  Settings->StartMode = rgStartMode->ItemIndex;

  switch (rgCsbDevice->ItemIndex)
  {
    case 0:
      Settings->Device = "";
      break;
    case 1:
      Settings->Device = "COM1";
      break;
    case 2:
      Settings->Device = "COM2";
      break;
    case 3:
      Settings->Device = "COM3";
      break;
    case 4:
      Settings->Device = "COM4";
      break;
    case 5:
      Settings->Device = "USB";
      break;
  }

  switch (rgOutputPrefix->ItemIndex)
  {
    case 0:
      Settings->Prefix = "";
      break;
    case 1:
      Settings->Prefix = "<ENTER>";
      break;
    case 2:
      Settings->Prefix = "<TAB>";
      break;
  }

  switch (rgOutputPostfix->ItemIndex)
  {
    case 0:
      Settings->Postfix = "";
      break;
    case 1:
      Settings->Postfix = "<ENTER>";
      break;
    case 2:
      Settings->Postfix = "<TAB>";
      break;
  }

  switch (rgScanDelay->ItemIndex)
  {
    case 0:
      Settings->ScanDelay = 0;
      break;
    case 1:
      Settings->ScanDelay = 5;
      break;
    case 2:
      Settings->ScanDelay = 10;
      break;
    case 3:
      Settings->ScanDelay = 20;
      break;
    case 4:
      Settings->ScanDelay = 50;
      break;
    case 5:
      Settings->ScanDelay = 100;
      break;
  }

  Settings->ScanFilter = rgScanFilter->ItemIndex;
  Settings->ScanBeep = cbBeep->Checked;
  Settings->RemoveLeading0 = cbRemoveLeading0->Checked;

  /* Mifare screen */
  Settings->MifareBlock = udMifareBlock->Position;
  Settings->MifareOffset = udMifareOffset->Position;
  Settings->MifareSize = udMifareSize->Position;
  Settings->MifareKey = eMifareKey->Text;
  Settings->MifareFormat = rgMifareFormat->ItemIndex;
  Settings->MifareRevert = cbMifareRevert->Checked;

  /* 14443-A screen */
  Settings->Iso14443aSize = rg14443aSize->ItemIndex;
  Settings->Iso14443aFormat = rg14443aFormat->ItemIndex;
  Settings->Iso14443aRevert = cb14443aRevert->Checked;
  Settings->Iso14443aA = cb14443aA->Checked;
  Settings->Iso14443aATQ = cb14443aATQ->Checked;
  Settings->Iso14443aSAK = cb14443aSAK->Checked;

  /* 14443-B screen */
  Settings->Iso14443bFormat = rg14443bFormat->ItemIndex;
  Settings->Iso14443bRevert = cb14443bRevert->Checked;
  Settings->Iso14443bB = cb14443bB->Checked;
}

__fastcall TfConfig::TfConfig(TComponent * Owner):TForm(Owner)
{
}



void __fastcall TfConfig::btnOKClick(TObject * Sender)
{
  ScreenToSettings();
  Settings->SaveSettings();
  Close();
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::FormCreate(TObject * Sender)
{
  TIniFile *ini;

  ini = new TIniFile(ExtractFileDir(Application->ExeName) + "\\csbinfo.ini");
  AnsiString str_company = ini->ReadString("company", "name", "SpringCard");
  
  AnsiString str_product =
    ini->ReadString("product", "name", "CSB / SpringProx");
  delete ini;

  CsbActive = false;
  Settings = new TSettings();
  Settings->LoadSettings();
  SettingsToScreen();

  ConfigMutex = CreateMutex(NULL, false, "SPROX_ScanUid_Cfg");
  if (ConfigMutex != NULL)
    WaitForSingleObject(ConfigMutex, 1000);
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::FormDestroy(TObject * Sender)
{
  delete Settings;

  if (ConfigMutex != NULL)
  {
    ReleaseMutex(ConfigMutex);
    CloseHandle(ConfigMutex);
  }
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::btnCancelClick(TObject * Sender)
{
  if (MessageBox(0, "Exit without saving ?", Caption.c_str(), MB_YESNO|MB_ICONQUESTION) == IDYES)
    Close();
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::rgScanModeClick(TObject * Sender)
{
  switch (rgScanMode->ItemIndex)
  {
    case 0:
      ts14443a->TabVisible = true;
      ts14443b->TabVisible = true;
      tsMifare->TabVisible = false;
      break;
    case 1:
      ts14443a->TabVisible = true;
      ts14443b->TabVisible = false;
      tsMifare->TabVisible = false;
      break;
    case 2:
      ts14443a->TabVisible = false;
      ts14443b->TabVisible = true;
      tsMifare->TabVisible = false;
      break;
    case 3:
      ts14443a->TabVisible = false;
      ts14443b->TabVisible = false;
      tsMifare->TabVisible = true;
      break;
  }
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::rg14443aSizeClick(TObject * Sender)
{
  if (rg14443aSize->ItemIndex == 0)
    rg14443aFormat->ItemIndex = 0;
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::rg14443aFormatClick(TObject * Sender)
{
  if (rg14443aFormat->ItemIndex == 1)
  {
    rg14443aSize->ItemIndex = 1;
    cb14443aA->Checked = false;
    cb14443aATQ->Checked = false;
    cb14443aSAK->Checked = false;
  }
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::rg14443bSizeClick(TObject * Sender)
{
  if (rg14443bSize->ItemIndex == 0)
    rg14443bFormat->ItemIndex = 0;
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::rg14443bFormatClick(TObject * Sender)
{
  if (rg14443bFormat->ItemIndex == 1)
  {
    rg14443bSize->ItemIndex = 1;
    cb14443bB->Checked = false;
  }
}

//---------------------------------------------------------------------------


void __fastcall TfConfig::btnTestClick(TObject * Sender)
{
  if (btnTest->Down)
    lbTestStatus->Caption = "Starting up...";
  tmrWork->Enabled = btnTest->Down;
  if (!btnTest->Down)
  {
    lbTestStatus->Caption = "Not active";
    if (CsbActive)
    {
      SPROX_ReaderClose();
      CsbActive = false;
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::tmrWorkTimer(TObject * Sender)
{
  short rc;

  unsigned char a_atq[2];
  unsigned char a_uid[12];
  unsigned char a_uidlen;
  unsigned char a_sak[1];
  unsigned char b_atq[11];
  unsigned char mif_key[6];
  unsigned char mif_data[16];

  static AnsiString PreviousTagIdent = "";
  AnsiString TagIdent = "";

  tmrWork->Enabled = false;
  ScreenToSettings();

  if (CsbActive)
  {
    if ((Settings->ScanMode == 0) || (Settings->ScanMode == 2))
    {
      /* ISO 14443-B part */
      rc = SPROX_B_SelectAny(0, b_atq);
      if (rc == MI_OK)
      {
        /* Process 14443-B information */
        TagIdent = Settings->Format14443B(b_atq);
        goto done;
      } else if (rc < -128)
      {
        /* Fatal error */
        CsbActive = false;
        goto done;
      }
    }

    if ((Settings->ScanMode == 0) || (Settings->ScanMode == 1)
        || (Settings->ScanMode == 3))
    {
      /* ISO 14443-A part */
      a_uidlen = sizeof(a_uid);
      rc = SPROX_A_SelectAny(a_atq, a_uid, &a_uidlen, a_sak);
      if (rc == MI_OK)
      {
        if (Settings->ScanMode == 3)
        {
          /* Check that this is a Mifare */
          if ((a_atq[1] == 0x00)
              && ((a_atq[0] == 0x02) || (a_atq[0] == 0x04)))
          {
            if (Settings->GetMifareKey(mif_key))
              rc =
                SPROX_MifStReadBlock(NULL, Settings->MifareBlock, mif_data,
                                     mif_key);
            else
              rc =
                SPROX_MifStReadBlock(NULL, Settings->MifareBlock, mif_data,
                                     NULL);
            if (rc == MI_OK)
            {
              /* Read successfull */
              TagIdent = Settings->FormatMifare(mif_data);
            } else if (rc < -128)
            {
              /* Fatal error */
              CsbActive = false;
              goto done;
            }
          }
        } else
        {
          /* Process 14443-A information */
          TagIdent = Settings->Format14443A(a_atq, a_uid, a_uidlen, a_sak);
        }

      } else if (rc < -128)
      {
        /* Fatal error */
        CsbActive = false;
        goto done;
      }
    }

  done:

    if (!CsbActive)
    {
      SPROX_ReaderClose();
      lbTestStatus->Caption = "Reader lost";
    } else if (TagIdent != "")
    {
      if (PreviousTagIdent == TagIdent)
      {
        /* This is the same tag as earlier */
      } else
      {
        /* New tag */
        PreviousTagIdent = TagIdent;
        if (Settings->ScanBeep)
          MessageBeep(0xFFFFFFFF);
      }

      eTest->Text = TagIdent;
      lbTestStatus->Caption = "Remove tag";
    } else
    {
      lbTestStatus->Caption = "Waiting for a tag";
    }

  } else
  {
    if (SPROX_ReaderOpen(Settings->Device.c_str()) == MI_OK)
    {
      CsbActive = true;
      SPROX_ControlLedY(0, 0, 0);
      SPROX_ControlRF(0);
      lbTestStatus->Caption = "Waiting for a tag";
    } else
    {
      lbTestStatus->Caption = "Reader not found";
    }
  }

  tmrWork->Enabled = true;
}

//---------------------------------------------------------------------------

void __fastcall TfConfig::FormClose(TObject * Sender, TCloseAction & Action)
{
  if (CsbActive)
    SPROX_ReaderClose();
}

//---------------------------------------------------------------------------
